#include "lidia_elf.h"

	.text
	.align 4
	.globl USCORE(DigitVecMult)
USCORE(DigitVecMult):
	pushl %ebp
	pushl %ebx
	pushl %edi
	pushl %esi
	movl 20(%esp),%ebx
	movl 24(%esp),%edi
	movl 28(%esp),%esi
	movl 32(%esp),%ecx
	xorl %ebp,%ebp
	testl %ecx,%ecx
	jz L2
L1:
	movl (%edi),%eax
	addl $4,%edi
	mull %esi
	addl %ebp,%eax
	movl %edx,%ebp
	adcl $0,%ebp
	movl %eax,(%ebx)
	addl $4,%ebx
	decl %ecx
	jnz L1
L2:
	movl %ebp,%eax
	popl %esi
	popl %edi
	popl %ebx
	popl %ebp
	ret
